/* drzefko 0.5.0
 *  by Bartosz Taudul <wolf@pld.org.pl>
 *  
 *  this thing is under gnu gpl v2
 */

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <time.h>
#include <malloc.h>
#include <math.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>
#include <SDL_video.h>
#include <SDL_image.h>
#include "drzefko.h"

int minimalna_liczba_odrostow=2;
int max_liczba_odrostow=3;
int dlugosc_drzefka=5;
int jak_dokladnie_mam_rysowac_drzefko=3;
int rob_zrzuty=0;
int rozmiar_x=500;
int rozmiar_y=700;
int liscie=0;

SDL_Surface *skrin;
struct galonzka *drzefko;
int node_count=0;
int swiatlosc=1;
int polerowanie=1;
int obracanie=1;
int linie=0;

double ox=0;
double oy=0;
double oz=-20;

Uint32 timer_now,timer_old;
int timer_delta;

/* czy klawisze s przycinite */
int p_s=1;
int p_l=1;
int p_space=1;
int p_w=1;

/* tekstury */
int t_lisc;

void powiedz_mi_cos_na_temat_pamieci()
{
#ifndef WIN32
	struct mallinfo dupa=mallinfo();
	
	printf("Zearem %d KB pamici.\n",dupa.uordblks/1024);
#endif
}

void zaladuj_liscia()
{
	SDL_Surface *obrazek;

	glGenTextures(1,&t_lisc);
	
	if((obrazek=IMG_Load(DATADIR"lisc.png"))==NULL)
	{
		printf("Nie mog zaadowa "DATADIR"lisc.png\n");
		exit(1);
	}
	
	glBindTexture(GL_TEXTURE_2D,t_lisc);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,obrazek->w,obrazek->h,0,\
			GL_RGB,GL_UNSIGNED_BYTE,obrazek->pixels);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_R,GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,\
			GL_LINEAR_MIPMAP_LINEAR);

	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB,obrazek->w,obrazek->h,\
			GL_RGB,GL_UNSIGNED_BYTE,obrazek->pixels);

	SDL_FreeSurface(obrazek);
}

void czary_mary_benc_wlacz_grafike()
{
	GLfloat tmp[4];
	char tytul_okna[255];

	SDL_Init(SDL_INIT_VIDEO);
	atexit(SDL_Quit);
	
	if((skrin=SDL_SetVideoMode(rozmiar_x,rozmiar_y,24,SDL_OPENGL))==NULL)
	{
		printf("%s\n",SDL_GetError());
		exit(1);
	}
	sprintf(tytul_okna,"drzefko %s",VERSION);
	SDL_WM_SetCaption(tytul_okna,"drzefko");

	glViewport(0,0,rozmiar_x,rozmiar_y);
	glClearColor(0,0,0,0);
	glClearDepth(1);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glEnable(GL_NORMALIZE);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0,(GLfloat)rozmiar_x/(GLfloat)rozmiar_y,0.1,100);
	glMatrixMode(GL_MODELVIEW);

	tmp[0]=tmp[1]=tmp[2]=0.1; tmp[3]=1;
	glLightfv(GL_LIGHT0,GL_AMBIENT,tmp);
	tmp[0]=tmp[1]=tmp[2]=tmp[3]=1;
	glLightfv(GL_LIGHT0,GL_DIFFUSE,tmp);
	tmp[0]=-5; tmp[1]=1; tmp[2]=4; tmp[3]=0;
	glLightfv(GL_LIGHT0,GL_POSITION,tmp);

	tmp[0]=0; tmp[1]=0; tmp[2]=2; tmp[3]=1;
	glLightfv(GL_LIGHT1,GL_DIFFUSE,tmp);
	tmp[0]=20; tmp[1]=-4; tmp[2]=0; tmp[3]=0;
	glLightfv(GL_LIGHT1,GL_POSITION,tmp);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
}

struct galonzka *zrob_galonzke(int poziom_drzefka,int odcinek_galenzi)
{
	int i,j;
	struct galonzka *dupa;

	if(poziom_drzefka<0)
		return NULL;

	if((dupa=(struct galonzka *)malloc(sizeof(struct galonzka)))==NULL)
	{
		printf("Zapomniaem co miaem zrobi.\n");
		exit(1);
	}
	node_count++;

	i=random()%(max_liczba_odrostow-minimalna_liczba_odrostow+1) \
		+minimalna_liczba_odrostow;	/* przedzia min-max */
	
	if(poziom_drzefka==jak_dokladnie_mam_rysowac_drzefko&& \
				odcinek_galenzi==0)
		i=0;			/* przy ziemi nie ma by gazi */

	if(poziom_drzefka==0)
		dupa->jaki_kolor_ma_galonzka=kolor_lisci;
	else
		dupa->jaki_kolor_ma_galonzka=kolor_galenzi;

	for(j=0;j<i;j++)
	{
		dupa->kierunek_w_jakim_spoglonda_galonzka[j]=random()%360;
		dupa->jak_bardzo_do_sloneczka_ciongnie_galonzke[j]=random()%60+40;
		dupa->opis_galonzki[j]=zrob_galonzke(poziom_drzefka-1,0);
	}
	if(i!=max_liczba_odrostow)
		for(j=i;j<max_liczba_odrostow;j++)
			dupa->opis_galonzki[j]=NULL;
	
	if((poziom_drzefka!=0)&&(odcinek_galenzi<dlugosc_drzefka)&& \
	(random()%10>1||poziom_drzefka==jak_dokladnie_mam_rysowac_drzefko))
		dupa->nastepna_galonzka= \
			zrob_galonzke(poziom_drzefka,odcinek_galenzi+1);
	else
		dupa->nastepna_galonzka=NULL;

	return dupa;
}

void zbuduj_drzefko()
{
	char tytul_okna[255];

	printf("Budowanie drzefka...\n");
	sprintf(tytul_okna,"drzefko %s - budowanie drzefka...",VERSION);
	SDL_WM_SetCaption(tytul_okna,"drzefko");
	srandom(time(0));
	drzefko=zrob_galonzke(jak_dokladnie_mam_rysowac_drzefko,0);
	printf("Drzefko skada si z %d elementw.\n",node_count);
	sprintf(tytul_okna,"drzefko %s (%d elementw)",VERSION,node_count);
	SDL_WM_SetCaption(tytul_okna,"drzefko");
	
	powiedz_mi_cos_na_temat_pamieci();
}

void show_node(short int kolor,int zakonczenie)
{
	if(kolor==kolor_lisci)
	{
		glCallList(dlist_lisc);
	}else if(zakonczenie==0)
	{
		glCallList(dlist_galonz);
	}else if(zakonczenie==1)
	{
		glCallList(dlist_koniec_galonzi);
	}else
		glCallList(dlist_pieniek);
}

void quadex(double x, double y)
{
	glTexCoord2d(x,y);
	glVertex3d(1-x,1-y,0);
}

void zbuduj_displej_listy()
{
	GLfloat tmp[4];

	/* li */
	glNewList(dlist_lisc,GL_COMPILE);
	if(liscie)
	{
		glDisable(GL_CULL_FACE);
		glPushMatrix();
		glTranslatef(0.175,0.175,0);
		glScaled(2,2,2);
		tmp[0]=1; tmp[1]=1; tmp[2]=1; tmp[3]=1;
		glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
		glMaterialfv(GL_BACK,GL_DIFFUSE,tmp);
		tmp[0]=0.25; tmp[1]=0.25; tmp[2]=0.25; tmp[3]=1;
		glMaterialfv(GL_FRONT,GL_AMBIENT,tmp);
		glMaterialfv(GL_BACK,GL_AMBIENT,tmp);
		glColor3f(1,1,1);
//		glBindTexture(GL_TEXTURE_2D,t_lisc);
		glEnable(GL_TEXTURE_2D);
		glBegin(GL_TRIANGLES);
			glNormal3f(0,0,-1);
			quadex(.0546875,.0234375);	/* 7 */
			quadex(.076171875,.095703125);	/* 6 */
			quadex(.3359375,.07421875);	/* 8 */

			quadex(.076171875,.095703125);	/* 6 */
			quadex(.162109375,.6875);	/* 5 */
			quadex(.3359375,.07421875);	/* 8 */

			quadex(.3359375,.07421875);	/* 8 */
			quadex(.162109375,.6875);	/* 5 */
			quadex(.673828125,.189453125);	/* 9 */

			quadex(.162109375,.6875);	/* 5 */
			quadex(.29296875,.9140625);	/* 4 */
			quadex(.673828125,.189453125);	/* 9 */

			quadex(.673828125,.189453125);	/* 9 */
			quadex(.29296875,.9140625);	/* 4 */
			quadex(.8828125,.359375);	/* 10 */
			
			quadex(.8828125,.359375);	/* 10 */
			quadex(.29296875,.9140625);	/* 4 */
			quadex(.525390625,.986328125);	/* 3 */

			quadex(.8828125,.359375);	/* 10 */
			quadex(.525390625,.986328125);	/* 3 */
			quadex(.990234375,.56640625);	/* 11 */

			quadex(.990234375,.56640625);	/* 11 */
			quadex(.525390625,.986328125);	/* 3 */
			quadex(.802734375,.84765625);	/* 1 */

			quadex(.990234375,.56640625);	/* 11 */
			quadex(.802734375,.84765625);	/* 1 */
			quadex(.833984375,.82421875);	/* 13 */

			quadex(.990234375,.56640625);	/* 11 */
			quadex(.833984375,.82421875);	/* 13 */
			quadex(.966796875,.7578125);	/* 12 */

			quadex(.525390625,.986328125);	/* 3 */
			quadex(.736328125,.94140625);	/* 2 */
			quadex(.802734375,.84765625);	/* 1 */

			quadex(.802734375,.84765625);	/* 1 */
			quadex(.974609375,1);		/* 0 */
			quadex(1,.97265625);		/* 14 */

			quadex(1,.97265625);		/* 14 */
			quadex(.833984375,.82421875);	/* 13 */
			quadex(.802734375,.84765625);	/* 1 */
		glEnd();
		glPopMatrix();
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_CULL_FACE);
	}
	else
	{
		tmp[0]=0.08; tmp[1]=0.88; tmp[2]=0.05; tmp[3]=1;
		glColor3f(0.08,0.88,0.05);
		glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
		glBegin(GL_TRIANGLE_FAN);
			glNormal3f(-0.442,-0.147,-0.885);
			glVertex3f(0,1.5,-0.25);
			glVertex3f(0,0,0);
			glVertex3f(-0.3,1.5,-0.1);
			glNormal3f(-0.442,0.147,-0.885);
			glVertex3f(0,3,0);
			glNormal3f(0.442,0.147,-0.885);
			glVertex3f(0.3,1.5,-0.1);
			glNormal3f(0.442,-0.147,-0.885);
			glVertex3f(0,0,0);
		glEnd();
		glBegin(GL_TRIANGLE_FAN);
			glNormal3f(-0.418,0.143,0.897);
			glVertex3f(0,1.5,-0.24);
			glVertex3f(0,0,0);
			glVertex3f(0.3,1.5,-0.1);
			glNormal3f(-0.418,-0.143,0.897);
			glVertex3f(0,3,0);
			glNormal3f(0.418,-0.143,0.897);
			glVertex3f(-0.3,1.5,-0.1);
			glNormal3f(0.418,0.143,0.897);
			glVertex3f(0,0,0);
		glEnd();
	}
	glEndList();

	/* ga */
	glNewList(dlist_galonz,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_QUAD_STRIP);
		glNormal3f(0,0.005,-0.999);
		glVertex3f(-0.15,0,-0.15);
		glVertex3f(-0.135,2.5,-0.135);
		glVertex3f(0.15,0,-0.15);
		glVertex3f(0.135,2.5,-0.135);
		glNormal3f(0.999,-0.005,0);
		glVertex3f(0.15,0,0.15);
		glVertex3f(0.135,2.5,0.135);
		glNormal3f(0,-0.005,0.999);
		glVertex3f(-0.15,0,0.15);
		glVertex3f(-0.135,2.5,0.135);
		glNormal3f(-0.999,0.005,0);
		glVertex3f(-0.15,0,-0.15);
		glVertex3f(-0.135,2.5,-0.135);
	glEnd();
	glEndList();
	
	/* koniec gazi */
	glNewList(dlist_koniec_galonzi,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0,0.0428,-0.999);
		glVertex3f(0,3.5,0);
		glVertex3f(0.15,0,-0.15);
		glVertex3f(-0.15,0,-0.15);
		glNormal3f(-0.999,0.0428,0);
		glVertex3f(-0.15,0,0.15);
		glNormal3f(0,0.0428,0.999);
		glVertex3f(0.15,0,0.15);
		glNormal3f(0.999,0.0428,0);
		glVertex3f(0.15,0,-0.15);
	glEnd();
	glEndList();

	/* podstawa */
	glNewList(dlist_pieniek,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_QUAD_STRIP);
		glNormal3f(0,0.339,-0.941);
		glVertex3f(-0.225,0,-0.225);
		glVertex3f(-0.135,2.5,-0.135);
		glVertex3f(0.225,0,-0.225);
		glVertex3f(0.135,2.5,-0.135);
		glNormal3f(0.941,-0.339,0);
		glVertex3f(0.225,0,0.225);
		glVertex3f(0.135,2.5,0.135);
		glNormal3f(0,-0.338,0.941);
		glVertex3f(-0.225,0,0.225);
		glVertex3f(-0.135,2.5,0.135);
		glNormal3f(-0.941,0.338,0);
		glVertex3f(-0.225,0,-0.225);
		glVertex3f(-0.135,2.5,-0.135);
	glEnd();
	/* teren na ktrym drzefko stoi */
	tmp[0]=0; tmp[1]=0.94; tmp[2]=0; tmp[3]=1;
	glColor3f(0,0.94,0);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0,1,0);
		glVertex3f(0,0,0);
		glVertex3f(-4,0,-2);
		glVertex3f(-4,0,2);
		glVertex3f(-2,0,4);
		glVertex3f(2,0,4);
		glVertex3f(4,0,2);
		glVertex3f(4,0,-2);
		glVertex3f(2,0,-4);
		glVertex3f(-2,0,-4);
		glVertex3f(-4,0,-2);
	glEnd();
	glEndList();
}

void narysuj_galonzke(struct galonzka *dupa)
{
	int i;

	show_node(dupa->jaki_kolor_ma_galonzka, \
		(dupa==drzefko?2:(dupa->nastepna_galonzka==NULL?1:0)));
	
	for(i=0;i<max_liczba_odrostow;i++)
		if(dupa->opis_galonzki[i]!=NULL)
		{
			glPushMatrix();
			glTranslatef(0,2,0);
			if(dupa->opis_galonzki[i]->nastepna_galonzka!=NULL) // to nie li
				glScalef(0.7,0.7,0.7);
			else
				glScalef(0.8,0.8,0.8);
			glRotatef(dupa->kierunek_w_jakim_spoglonda_galonzka[i],0,1,0);
			glRotatef(dupa->jak_bardzo_do_sloneczka_ciongnie_galonzke[i],0,0,1);
			narysuj_galonzke(dupa->opis_galonzki[i]);
			glPopMatrix();
		}
	
	if(dupa->nastepna_galonzka!=NULL)
	{
		glPushMatrix();
		glTranslatef(0,2,0);
		glScalef(0.9,0.9,0.9);
		narysuj_galonzke(dupa->nastepna_galonzka);
		glPopMatrix();
	}
}

void narysuj_drzefko()
{
	double obrot=0;
	int i;
	SDL_Event zderzenie;
	char tytul_okna[255];
	SDL_Surface *temp;
	SDL_Surface *image;
	int idx;
	int mx,my,mb;
	
	glNewList(dlist_full,GL_COMPILE);
	narysuj_galonzke(drzefko);
	glEndList();
	timer_now=timer_old=SDL_GetTicks();
	timer_delta=0;

	if(rob_zrzuty==0)
	{
		while(1)
		{
			while(SDL_PollEvent(&zderzenie)==1)
			{
			if(zderzenie.type==SDL_QUIT)
				exit(0);
			if(zderzenie.type==SDL_KEYDOWN)
				switch(zderzenie.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						exit(0);
						break;
					case SDLK_l:
						if(p_l)
						{
							swiatlosc=!swiatlosc;
							if(!swiatlosc)
							{
								glDisable(GL_LIGHTING);
								printf("Bez owietlenia\n");
							}else{
								glEnable(GL_LIGHTING);
								printf("Z owietleniem\n");
							}
							p_l=0;
						}
						break;
					case SDLK_s:
						if(p_s)
						{
							polerowanie=!polerowanie;
							if(!polerowanie)
							{
								glShadeModel(GL_FLAT);
								printf("Flat shading.\n");
							}else{
								glShadeModel(GL_SMOOTH);
								printf("Smooth shading.\n");
							}
							p_s=0;
						}
						break;
					case SDLK_SPACE:
						if(p_space)
							obracanie=!obracanie;
						p_space=0;
						break;
					case SDLK_w:
						if(p_w)
						{
							linie=!linie;
							
							if(!linie)
							{
								glPolygonMode(GL_FRONT,GL_LINE);
								glPolygonMode(GL_BACK,GL_LINE);
							}else{
								glPolygonMode(GL_FRONT,GL_FILL);
								glPolygonMode(GL_BACK,GL_FILL);
							}
						}
						p_w=0;
						break;				
					default:
						printf("I co klawisze bez sensu naciskasz?!\n");
				}
			else
			{
				p_l=1;
				p_s=1;
				p_space=1;
				p_w=1;
			}
			}
			
			mb=SDL_GetRelativeMouseState(&mx,&my);

			if(mb&SDL_BUTTON(SDL_BUTTON_LEFT))
			{
				oy+=mx*0.3;
				ox+=my*0.3;

				if(ox>75)
					ox=75;
				else if(ox<-40)
					ox=-40;
			}
			else if(obracanie)
				oy+=timer_delta*0.033;

			if(mb&SDL_BUTTON(SDL_BUTTON_RIGHT))
			{
				oz+=my*0.1;

				if(oz>-10)
					oz=-10;
				else if(oz<-80)
					oz=-80;
			}

			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0,-5,oz);
			glRotatef(ox,1,0,0);
			glRotatef(oy,0,1,0);
//			narysuj_galonzke(drzefko);
			glCallList(dlist_full);
			SDL_GL_SwapBuffers();
			timer_now=SDL_GetTicks();
			timer_delta=timer_now-timer_old;
			timer_old=timer_now;
		}
	}else if(rob_zrzuty==1){
		/* tutaj robimy 72 obrazki i zrzucamy je do plikw */
		for(i=0;i<72;i++)
		{
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0,-5,-20);
			glRotatef(obrot+=5,0,1,0);
//			narysuj_galonzke(drzefko);
			glCallList(dlist_full);
			SDL_GL_SwapBuffers();
			
			sprintf(tytul_okna,"drzefko %s - %i%% zrobione",VERSION,(int)(((float)i/72.0)*100.0));
			SDL_WM_SetCaption(tytul_okna,"drzefko");
			
			image=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
			temp=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
			glReadPixels(0,0,rozmiar_x,rozmiar_y,GL_RGB,GL_UNSIGNED_BYTE,image->pixels);
			for(idx=0;idx<rozmiar_y;idx++)
				memcpy(temp->pixels+3*rozmiar_x*idx,(char *)image->pixels+3*rozmiar_x*(rozmiar_y-idx),3*rozmiar_x);
			SDL_SaveBMP(temp, zrzuty[i]);
			SDL_FreeSurface(image);
			SDL_FreeSurface(temp);
		}
	}else{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		glTranslatef(0,-5,-20);
//		narysuj_galonzke(drzefko);
		glCallList(dlist_full);
		SDL_GL_SwapBuffers();
		
		sprintf(tytul_okna,"drzefko %s",VERSION);
		SDL_WM_SetCaption(tytul_okna,"drzefko");
		
		image=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
		temp=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
		glReadPixels(0,0,rozmiar_x,rozmiar_y,GL_RGB,GL_UNSIGNED_BYTE,image->pixels);
		for(idx=0;idx<rozmiar_y;idx++)
			memcpy(temp->pixels+3*rozmiar_x*idx,(char *)image->pixels+3*rozmiar_x*(rozmiar_y-idx),3*rozmiar_x);
		SDL_SaveBMP(temp, "screenshot.bmp");
		SDL_FreeSurface(image);
		SDL_FreeSurface(temp);
	}
}

void przedstaw_siem()
{
	printf("  drzefko %s\n",VERSION);
	printf("by Bartosz Taudul <wolf@pld.org.pl>\n\n");
	printf("Opcje konfiguracyjne: %d/%d/%d/%d\n", \
			minimalna_liczba_odrostow,max_liczba_odrostow, \
			dlugosc_drzefka, jak_dokladnie_mam_rysowac_drzefko);
}

void pomoc()
{
	printf("  drzefko %s\n"
"by Bartosz Taudul <wolf@pld.org.pl>\n"
"\n"
"	-d %i	dugo gazi\n"
"	-h	ta pomoc\n"
"	-m %i	minimalna liczba gazi\n"
"	-M %i	maksymalna liczba gazi (<=10)\n"
"	-r %i	stopie rekursywnoci (wicej ni 5 nie ma sensu)\n"
"	-v	pokaz wersj i wyjd\n"
"	-x %i	szeroko okna\n"
"	-y %i	wysoko okna\n"
"	-t %i	teksturowane licie\n"
"	-z %i	1 -- jeden screenshot\n"
"		2 -- 72 screenshoty (peny obrt)\n",VERSION, \
		dlugosc_drzefka, \
		minimalna_liczba_odrostow, \
		max_liczba_odrostow, \
		jak_dokladnie_mam_rysowac_drzefko, \
		rozmiar_x, \
		rozmiar_y, \
		liscie, \
		rob_zrzuty);
}

int main(int argc,char *argv[])
{
	int c,d;

	while(1)
	{
		c=getopt(argc,argv,"d:h?m:M:r:vx:y:t:z:");
		if(c==-1)
			break;
		
		switch(c)
		{
			case 'd':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -d\n");
				else
					dlugosc_drzefka=d;
				break;

			case 'r':
				d=atoi(optarg);
				if(d<0)
					printf("Niepoprawna warto parametru -r\n");
				else
					jak_dokladnie_mam_rysowac_drzefko=d;
				break;
			
			case 'h':
			case '?':
				pomoc();
				exit(0);
				break;

			case 'm':
				d=atoi(optarg);
				if(d<0)
					printf("Niepoprawna warto parametru -m\n");
				else
					minimalna_liczba_odrostow=d;
				break;

			case 'M':
				d=atoi(optarg);
				if(d<0||d>10)
					printf("Niepoprawna warto parametru -d\n");
				else
					max_liczba_odrostow=d;
				break;

			case 'v':
				przedstaw_siem();
				exit(0);
				break;

			case 'x':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -m\n");
				else
					rozmiar_x=d;
				break;

			case 'y':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -m\n");
				else
					rozmiar_y=d;
				break;
				
			case 't':
				d=atoi(optarg);
				if(d<0||d>1)
					printf("Za warto opcji -t\n");
				else
				{
					printf("Opcja -t nie zaimplementowana.\n");
					liscie=d;
				}
				break;

			case 'z':
				d=atoi(optarg);
				if(d<0||d>2)
					printf("Za warto opcji -z\n");
				else
					rob_zrzuty=d;
				break;

			default:
				printf("Huh?\n");
				break;
		}
	}

	przedstaw_siem();
	czary_mary_benc_wlacz_grafike();
	if(liscie)
		zaladuj_liscia();
	zbuduj_displej_listy();
	zbuduj_drzefko();
	narysuj_drzefko();

	return 0;
}
